Index: CKEditor/branches/versions/3.3.x/_source/lang/no.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/no.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/no.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -32,9 +32,9 @@
 	 * of reading non-English words. So be careful while translating it.
 	 */
-	editorTitle : 'Rich text editor, %1, press ALT 0 for help.', // MISSING
+	editorTitle : 'Rikteksteditor, %1, trykk ALT 0 for hjelp.',
 
 	// ARIA descriptions.
-	toolbar	: 'Toolbar', // MISSING
-	editor	: 'Rich Text Editor', // MISSING
+	toolbar	: 'Verktøylinje',
+	editor	: 'Rikteksteditor',
 
 	// Toolbar buttons without dialogs.
@@ -93,6 +93,6 @@
 		ok				: 'OK',
 		cancel			: 'Avbryt',
-		close			: 'Close', // MISSING
-		preview			: 'Preview', // MISSING
+		close			: 'Lukk',
+		preview			: 'Forhåndsvis',
 		generalTab		: 'Generelt',
 		advancedTab		: 'Avansert',
@@ -100,10 +100,10 @@
 		confirmNewPage	: 'Alle endringer som er gjort i dette innholdet vil bli tapt. Er du sikker på at du vil laste en ny side?',
 		confirmCancel	: 'Noen av valgene har blitt endret. Er du sikker på at du vil lukke dialogen?',
-		options			: 'Options', // MISSING
-		target			: 'Target', // MISSING
-		targetNew		: 'New Window (_blank)', // MISSING
-		targetTop		: 'Topmost Window (_top)', // MISSING
-		targetSelf		: 'Same Window (_self)', // MISSING
-		targetParent	: 'Parent Window (_parent)', // MISSING
+		options			: 'Valg',
+		target			: 'Mål',
+		targetNew		: 'Nytt vindu (_blank)',
+		targetTop		: 'Hele vindu (_top)',
+		targetSelf		: 'Samme vindu (_self)',
+		targetParent	: 'Foreldrevindu (_parent)',
 
 		// Put the voice-only part of the label in the span.
@@ -128,5 +128,5 @@
 	{
 		toolbar		: 'Sett inn/Rediger lenke',
-		other 		: '<annet>',
+		other 		: '<other>', // MISSING
 		menu		: 'Rediger lenke',
 		title		: 'Lenke',
@@ -136,5 +136,5 @@
 		advanced	: 'Avansert',
 		type		: 'Lenketype',
-		toUrl		: 'URL', // MISSING
+		toUrl		: 'URL',
 		toAnchor	: 'Lenke til anker i teksten',
 		toEmail		: 'E-post',
@@ -223,5 +223,5 @@
 		widthPx		: 'piksler',
 		widthPc		: 'prosent',
-		widthUnit	: 'width unit', // MISSING
+		widthUnit	: 'Bredde-enhet',
 		height		: 'Høyde',
 		cellSpace	: 'Cellemarg',
@@ -386,5 +386,5 @@
 		height		: 'Høyde',
 		lockRatio	: 'Lås forhold',
-		unlockRatio	: 'Unlock Ratio', // MISSING
+		unlockRatio	: 'Ikke lås forhold',
 		resetSize	: 'Tilbakestill størrelse',
 		border		: 'Ramme',
@@ -399,9 +399,9 @@
 		img2Button	: 'Vil du endre det valgte bildet til en bildeknapp?',
 		urlMissing	: 'Bildets adresse mangler.',
-		validateWidth	: 'Width must be a whole number.', // MISSING
-		validateHeight	: 'Height must be a whole number.', // MISSING
-		validateBorder	: 'Border must be a whole number.', // MISSING
-		validateHSpace	: 'HSpace must be a whole number.', // MISSING
-		validateVSpace	: 'VSpace must be a whole number.' // MISSING
+		validateWidth	: 'Bredde må være ett nummer.',
+		validateHeight	: 'Høyde må være ett nummer.',
+		validateBorder	: 'Ramme må være ett nummer.',
+		validateHSpace	: 'HSpace må være ett nummer.',
+		validateVSpace	: 'VSpace må være ett nummer.'
 	},
 
@@ -490,5 +490,5 @@
 	elementsPath :
 	{
-		eleLabel : 'Elements path', // MISSING
+		eleLabel : 'Element-sti',
 		eleTitle : '%1 element'
 	},
@@ -512,17 +512,17 @@
 	{
 		title		: 'Lim inn',
-		cutError	: 'Din nettlesers sikkerhetsinstillinger tillater ikke automatisk klipping av tekst. Vennligst bruk snareveien (Ctrl/Cmd+X).',
-		copyError	: 'Din nettlesers sikkerhetsinstillinger tillater ikke automatisk kopiering av tekst. Vennligst bruk snareveien (Ctrl/Cmd+C).',
-		pasteMsg	: 'Vennligst lim inn i den følgende boksen med tastaturet (<STRONG>Ctrl/Cmd+V</STRONG>) og trykk <STRONG>OK</STRONG>.',
+		cutError	: 'Din nettlesers sikkerhetsinstillinger tillater ikke automatisk klipping av tekst. Vennligst bruk snareveien (Ctrl+X).',
+		copyError	: 'Din nettlesers sikkerhetsinstillinger tillater ikke automatisk kopiering av tekst. Vennligst bruk snareveien (Ctrl+C).',
+		pasteMsg	: 'Vennligst lim inn i den følgende boksen med tastaturet (<STRONG>Ctrl+V</STRONG>) og trykk <STRONG>OK</STRONG>.',
 		securityMsg	: 'Din nettlesers sikkerhetsinstillinger gir ikke redigeringsverktøyet direkte tilgang til utklippstavlen. Du må lime det igjen i dette vinduet.',
-		pasteArea	: 'Paste Area' // MISSING
+		pasteArea	: 'Innlimingsområde'
 	},
 
 	pastefromword :
 	{
-		confirmCleanup	: 'The text you want to paste seems to be copied from Word. Do you want to clean it before pasting?', // MISSING
+		confirmCleanup	: 'Teksten du limer inn ser ut til å være kopiert fra Word. Vil du renske den før du limer den inn?',
 		toolbar			: 'Lim inn fra Word',
 		title			: 'Lim inn fra Word',
-		error			: 'It was not possible to clean up the pasted data due to an internal error' // MISSING
+		error			: 'Det var ikke mulig å renske den innlimte teksten på grunn av en intern feil'
 	},
 
@@ -548,5 +548,5 @@
 	{
 		label		: 'Stil',
-		panelTitle	: 'Formatting Styles', // MISSING
+		panelTitle	: 'Stilformater',
 		panelTitle1	: 'Blokkstiler',
 		panelTitle2	: 'Inlinestiler',
@@ -573,17 +573,17 @@
 	div :
 	{
-		title				: 'Create Div Container', // MISSING
-		toolbar				: 'Create Div Container', // MISSING
-		cssClassInputLabel	: 'Stylesheet Classes', // MISSING
-		styleSelectLabel	: 'Style', // MISSING
-		IdInputLabel		: 'Id', // MISSING
-		languageCodeInputLabel	: ' Language Code', // MISSING
-		inlineStyleInputLabel	: 'Inline Style', // MISSING
+		title				: 'Sett inn Div Container',
+		toolbar				: 'Sett inn Div Container',
+		cssClassInputLabel	: 'Stilark-klasser',
+		styleSelectLabel	: 'Stil',
+		IdInputLabel		: 'Id',
+		languageCodeInputLabel	: ' Språk-kode',
+		inlineStyleInputLabel	: 'Inlinestiler',
 		advisoryTitleInputLabel	: 'Advisory Title', // MISSING
-		langDirLabel		: 'Language Direction', // MISSING
-		langDirLTRLabel		: 'Left to Right (LTR)', // MISSING
-		langDirRTLLabel		: 'Right to Left (RTL)', // MISSING
-		edit				: 'Edit Div', // MISSING
-		remove				: 'Remove Div' // MISSING
+		langDirLabel		: 'Språkretning',
+		langDirLTRLabel		: 'Venstre til høyre (VTH)',
+		langDirRTLLabel		: 'Høyre til venstre (HTV)',
+		edit				: 'Rediger Div',
+		remove				: 'Fjern Div'
   	},
 
@@ -606,5 +606,5 @@
 		textColorTitle	: 'Tekstfarge',
 		bgColorTitle	: 'Bakgrunnsfarge',
-		panelTitle		: 'Colors', // MISSING
+		panelTitle		: 'Farger',
 		auto			: 'Automatisk',
 		more			: 'Flere farger...'
@@ -613,44 +613,44 @@
 	colors :
 	{
-		'000' : 'Black', // MISSING
+		'000' : 'Svart',
 		'800000' : 'Maroon', // MISSING
 		'8B4513' : 'Saddle Brown', // MISSING
 		'2F4F4F' : 'Dark Slate Gray', // MISSING
 		'008080' : 'Teal', // MISSING
-		'000080' : 'Navy', // MISSING
+		'000080' : 'Marine',
 		'4B0082' : 'Indigo', // MISSING
-		'696969' : 'Dim Gray', // MISSING
+		'696969' : 'Svak grå',
 		'B22222' : 'Fire Brick', // MISSING
-		'A52A2A' : 'Brown', // MISSING
+		'A52A2A' : 'Brun',
 		'DAA520' : 'Golden Rod', // MISSING
-		'006400' : 'Dark Green', // MISSING
-		'40E0D0' : 'Turquoise', // MISSING
-		'0000CD' : 'Medium Blue', // MISSING
+		'006400' : 'Mørk grå',
+		'40E0D0' : 'Turkis',
+		'0000CD' : 'Medium Blå',
 		'800080' : 'Purple', // MISSING
-		'808080' : 'Gray', // MISSING
+		'808080' : 'Grå',
 		'F00' : 'Red', // MISSING
-		'FF8C00' : 'Dark Orange', // MISSING
-		'FFD700' : 'Gold', // MISSING
-		'008000' : 'Green', // MISSING
+		'FF8C00' : 'Mørk oransje',
+		'FFD700' : 'gull',
+		'008000' : 'Grønn',
 		'0FF' : 'Cyan', // MISSING
-		'00F' : 'Blue', // MISSING
-		'EE82EE' : 'Violet', // MISSING
-		'A9A9A9' : 'Dark Gray', // MISSING
+		'00F' : 'Blå',
+		'EE82EE' : 'Fiolett',
+		'A9A9A9' : 'Mørk grå',
 		'FFA07A' : 'Light Salmon', // MISSING
-		'FFA500' : 'Orange', // MISSING
-		'FFFF00' : 'Yellow', // MISSING
+		'FFA500' : 'Oransje',
+		'FFFF00' : 'gul',
 		'00FF00' : 'Lime', // MISSING
 		'AFEEEE' : 'Pale Turquoise', // MISSING
-		'ADD8E6' : 'Light Blue', // MISSING
-		'DDA0DD' : 'Plum', // MISSING
-		'D3D3D3' : 'Light Grey', // MISSING
+		'ADD8E6' : 'Lys Blå',
+		'DDA0DD' : 'Plomme',
+		'D3D3D3' : 'Lys grå',
 		'FFF0F5' : 'Lavender Blush', // MISSING
-		'FAEBD7' : 'Antique White', // MISSING
-		'FFFFE0' : 'Light Yellow', // MISSING
+		'FAEBD7' : 'Antikk-hvit',
+		'FFFFE0' : 'Lys gul',
 		'F0FFF0' : 'Honeydew', // MISSING
 		'F0FFFF' : 'Azure', // MISSING
 		'F0F8FF' : 'Alice Blue', // MISSING
 		'E6E6FA' : 'Lavender', // MISSING
-		'FFF' : 'White' // MISSING
+		'FFF' : 'Hvit'
 	},
 
@@ -704,5 +704,5 @@
 	},
 
-	toolbarCollapse	: 'Collapse Toolbar', // MISSING
-	toolbarExpand	: 'Expand Toolbar' // MISSING
+	toolbarCollapse	: 'Slå sammen verktøylinje',
+	toolbarExpand	: 'Vis verktøylinje'
 };
Index: CKEditor/branches/versions/3.3.x/_source/lang/pl.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/pl.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/pl.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/pt-br.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/pt-br.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/pt-br.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/pt.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/pt.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/pt.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/ro.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/ro.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/ro.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/ru.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/ru.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/ru.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/sk.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/sk.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/sk.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/sl.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/sl.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/sl.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/sr-latn.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/sr-latn.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/sr-latn.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/sr.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/sr.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/sr.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/sv.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/sv.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/sv.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/th.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/th.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/th.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/tr.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/tr.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/tr.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/uk.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/uk.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/uk.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/vi.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/vi.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/vi.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/zh-cn.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/zh-cn.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/zh-cn.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/lang/zh.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/lang/zh.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/lang/zh.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/basicstyles/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/basicstyles/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/basicstyles/plugin.js	(revision 5388)
@@ -43,4 +43,5 @@
 
 // Basic Inline Styles.
+
 /**
  * The style definition to be used to apply the bold style in the text.
@@ -51,5 +52,6 @@
  * config.coreStyles_bold = { element : 'span', attributes : {'class': 'Bold'} };
  */
-CKEDITOR.config.coreStyles_bold			= { element : 'strong', overrides : 'b' };
+CKEDITOR.config.coreStyles_bold = { element : 'strong', overrides : 'b' };
+
 /**
  * The style definition to be used to apply the italic style in the text.
@@ -57,7 +59,10 @@
  * @default { element : 'em', overrides : 'i' }
  * @example
- * CKEDITOR.config.coreStyles_italic		= { element : 'span', attributes : {'class': 'Italic'} };
+ * config.coreStyles_bold = { element : 'i', overrides : 'em' };
+ * @example
+ * CKEDITOR.config.coreStyles_italic = { element : 'span', attributes : {'class': 'Italic'} };
  */
-CKEDITOR.config.coreStyles_italic		= { element : 'em', overrides : 'i' };
+CKEDITOR.config.coreStyles_italic = { element : 'em', overrides : 'i' };
+
 /**
  * The style definition to be used to apply the underline style in the text.
@@ -65,7 +70,8 @@
  * @default { element : 'u' }
  * @example
- * CKEDITOR.config.coreStyles_underline	= { element : 'span', attributes : {'class': 'Underline'}};
+ * CKEDITOR.config.coreStyles_underline = { element : 'span', attributes : {'class': 'Underline'}};
  */
-CKEDITOR.config.coreStyles_underline	= { element : 'u' };
+CKEDITOR.config.coreStyles_underline = { element : 'u' };
+
 /**
  * The style definition to be used to apply the strike style in the text.
@@ -73,7 +79,8 @@
  * @default { element : 'strike' }
  * @example
- * CKEDITOR.config.coreStyles_strike		= { element : 'span', attributes : {'class': 'StrikeThrough'}, overrides : 'strike' };
+ * CKEDITOR.config.coreStyles_strike = { element : 'span', attributes : {'class': 'StrikeThrough'}, overrides : 'strike' };
  */
-CKEDITOR.config.coreStyles_strike		= { element : 'strike' };
+CKEDITOR.config.coreStyles_strike = { element : 'strike' };
+
 /**
  * The style definition to be used to apply the subscript style in the text.
@@ -81,7 +88,8 @@
  * @default { element : 'sub' }
  * @example
- * CKEDITOR.config.coreStyles_subscript	= { element : 'span', attributes : {'class': 'Subscript'}, overrides : 'sub' };
+ * CKEDITOR.config.coreStyles_subscript = { element : 'span', attributes : {'class': 'Subscript'}, overrides : 'sub' };
  */
-CKEDITOR.config.coreStyles_subscript	= { element : 'sub' };
+CKEDITOR.config.coreStyles_subscript = { element : 'sub' };
+
 /**
  * The style definition to be used to apply the superscript style in the text.
@@ -89,5 +97,5 @@
  * @default { element : 'sup' }
  * @example
- * CKEDITOR.config.coreStyles_superscript	= { element : 'span', attributes : {'class': 'Superscript'}, overrides : 'sup' };
+ * CKEDITOR.config.coreStyles_superscript = { element : 'span', attributes : {'class': 'Superscript'}, overrides : 'sup' };
  */
-CKEDITOR.config.coreStyles_superscript	= { element : 'sup' };
+CKEDITOR.config.coreStyles_superscript = { element : 'sup' };
Index: CKEditor/branches/versions/3.3.x/_source/plugins/clipboard/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/clipboard/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/clipboard/plugin.js	(revision 5388)
@@ -29,5 +29,6 @@
 		body.on( command, onExec );
 
-		doc.$.execCommand( command );
+		// IE6/7: document.execCommand has problem to paste into positioned element.
+		( CKEDITOR.env.version > 7 ? doc.$ : doc.$.selection.createRange() ) [ 'execCommand' ]( command );
 
 		body.removeListener( command, onExec );
@@ -68,4 +69,6 @@
 		exec : function( editor, data )
 		{
+			this.type == 'cut' && fixCut( editor );
+
 			var success = tryToCutCopy( editor, this.type );
 
@@ -182,5 +185,5 @@
 
 		// Create container to paste into
-		var pastebin = new CKEDITOR.dom.element( mode == 'text' ? 'textarea' : 'div', doc );
+		var pastebin = new CKEDITOR.dom.element( mode == 'text' ? 'textarea' : CKEDITOR.env.webkit ? 'body' : 'div', doc );
 		pastebin.setAttribute( 'id', 'cke_pastebin' );
 		// Safari requires a filler node inside the div to have the content pasted into it. (#4882)
@@ -248,4 +251,34 @@
 	}
 
+	// Cutting off control type element in IE standards breaks the selection entirely. (#4881)
+	function fixCut( editor )
+	{
+		if ( !CKEDITOR.env.ie || editor.document.$.compatMode == 'BackCompat' )
+			return;
+
+		var sel = editor.getSelection();
+		var control;
+		if( ( sel.getType() == CKEDITOR.SELECTION_ELEMENT ) && ( control = sel.getSelectedElement() ) )
+		{
+			var range = sel.getRanges()[ 0 ];
+			var dummy = editor.document.createText( '' );
+			dummy.insertBefore( control );
+			range.setStartBefore( dummy );
+			range.setEndAfter( control );
+			sel.selectRanges( [ range ] );
+
+			// Clear up the fix if the paste wasn't succeeded.
+			setTimeout( function()
+			{
+				// Element still online?
+				if ( control.getParent() )
+				{
+					dummy.remove();
+					sel.selectElement( control );
+				}
+			}, 0 );
+		}
+	}
+	
 	// Register the plugin.
 	CKEDITOR.plugins.add( 'clipboard',
@@ -318,5 +351,5 @@
 						function( evt )
 						{
-							if ( depressBeforePasteEvent )
+							if ( depressBeforeEvent )
 								return;
 
@@ -334,4 +367,5 @@
 						});
 
+					body.on( 'beforecut', function() { !depressBeforeEvent && fixCut( editor ); } );
 				});
 
@@ -339,14 +373,14 @@
 				if ( editor.contextMenu )
 				{
-					var depressBeforePasteEvent;
+					var depressBeforeEvent;
 					function stateFromNamedCommand( command )
 					{
-						// IE Bug: queryCommandEnabled('paste') fires also 'beforepaste',
+						// IE Bug: queryCommandEnabled('paste') fires also 'beforepaste(copy/cut)',
 						// guard to distinguish from the ordinary sources( either
 						// keyboard paste or execCommand ) (#4874).
-						CKEDITOR.env.ie && command == 'Paste'&& ( depressBeforePasteEvent = 1 );
+						CKEDITOR.env.ie && ( depressBeforeEvent = 1 );
 
 						var retval = editor.document.$.queryCommandEnabled( command ) ? CKEDITOR.TRISTATE_OFF : CKEDITOR.TRISTATE_DISABLED;
-						depressBeforePasteEvent = 0;
+						depressBeforeEvent = 0;
 						return retval;
 					}
Index: CKEditor/branches/versions/3.3.x/_source/plugins/colorbutton/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/colorbutton/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/colorbutton/plugin.js	(revision 5388)
@@ -87,11 +87,23 @@
 					panel.hide();
 
-					var style = new CKEDITOR.style( config['colorButton_' + type + 'Style'], { color : color || 'inherit' } );
 
 					editor.fire( 'saveSnapshot' );
+
+					// Clean up any conflicting style within the range.
+					new CKEDITOR.style( config['colorButton_' + type + 'Style'], { color : 'inherit' } ).remove( editor.document );
+
 					if ( color )
-						style.apply( editor.document );
-					else
-						style.remove( editor.document );
+					{
+						var colorStyle = config['colorButton_' + type + 'Style'];
+
+						colorStyle.childRule = type == 'back' ?
+							// It's better to apply background color as the innermost style. (#3599)
+							function(){ return false; } :
+							// Fore color style must be applied inside links instead of around it.
+							function( element ){ return element.getName() != 'a'; };
+
+						new CKEDITOR.style( colorStyle, { color : color } ).apply( editor.document );
+					}
+
 					editor.fire( 'saveSnapshot' );
 				});
@@ -215,11 +227,5 @@
 		element		: 'span',
 		styles		: { 'color' : '#(color)' },
-		overrides	: [ { element : 'font', attributes : { 'color' : null } } ],
-
-		// Fore color style must be applied inside links instead of around it.
-		childRule : function( element )
-		{
-			return element.getName() != 'a';
-		}
+		overrides	: [ { element : 'font', attributes : { 'color' : null } } ]
 	};
 
@@ -238,10 +244,4 @@
 	{
 		element		: 'span',
-		styles		: { 'background-color' : '#(color)' },
-
-		// It's better to apply background color as the innermost style. (#3599)
-		childRule : function( element )
-		{
-			return false;
-		}
+		styles		: { 'background-color' : '#(color)' }
 	};
Index: CKEditor/branches/versions/3.3.x/_source/plugins/contextmenu/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/contextmenu/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/contextmenu/plugin.js	(revision 5388)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -168,5 +168,5 @@
 
 					if ( nativeContextMenuOnCtrl
-						 && ( evt.$.ctrlKey || evt.$.metaKey ) )
+						 && ( CKEDITOR.env.mac ? evt.$.metaKey : evt.$.ctrlKey ) )
 						return;
 
@@ -206,5 +206,5 @@
 					     // Safari on Windows always show 'ctrlKey' as true in 'contextmenu' event,
 						// which make this property unreliable. (#4826)
-					     ( CKEDITOR.env.webkit ? holdCtrlKey : domEvent.$.ctrlKey || domEvent.$.metaKey ) )
+					     ( CKEDITOR.env.webkit ? holdCtrlKey : ( CKEDITOR.env.mac ? domEvent.$.metaKey : domEvent.$.ctrlKey ) ) )
 						return;
 
@@ -237,5 +237,5 @@
 					onKeyDown = function( event )
 					{
-						holdCtrlKey = event.data.$.ctrlKey || event.data.$.metaKey;
+						holdCtrlKey = CKEDITOR.env.mac ? event.data.$.metaKey : event.data.$.ctrlKey ;
 					},
 					resetOnKeyUp = function()
Index: CKEditor/branches/versions/3.3.x/_source/plugins/dialog/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/dialog/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/dialog/plugin.js	(revision 5388)
@@ -2658,5 +2658,5 @@
 		canUndo: false,
 
-		editorFocus : CKEDITOR.env.ie
+		editorFocus : CKEDITOR.env.ie || CKEDITOR.env.webkit
 	};
 
Index: CKEditor/branches/versions/3.3.x/_source/plugins/div/dialogs/div.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/div/dialogs/div.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/div/dialogs/div.js	(revision 5388)
@@ -485,4 +485,5 @@
 			onOk : function()
 			{
+				editor.fire( 'saveSnapshot' );
 				if ( command == 'editdiv' )
 					containers = [ this._element ];
@@ -499,4 +500,5 @@
 					!containers[ i ].getAttribute( 'style' ) && containers[ i ].removeAttribute( 'style' );
 				}
+				editor.fire( 'saveSnapshot' );
 
 				this.hide();
Index: CKEditor/branches/versions/3.3.x/_source/plugins/elementspath/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/elementspath/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/elementspath/plugin.js	(revision 5388)
@@ -45,5 +45,5 @@
 			var idBase = 'cke_elementspath_' + CKEDITOR.tools.getNextNumber() + '_';
 
-			editor._.elementsPath = { idBase : idBase };
+			editor._.elementsPath = { idBase : idBase, filters : [] };
 
 			editor.on( 'themeSpace', function( event )
@@ -57,15 +57,13 @@
 				});
 
-			var filters = editor.config.elementsPath_filters;
-
 			editor.on( 'selectionChange', function( ev )
 				{
-					var env = CKEDITOR.env;
-
-					var selection = ev.data.selection;
-
-					var element = selection.getStartElement(),
+					var env = CKEDITOR.env,
+						selection = ev.data.selection,
+						element = selection.getStartElement(),
 						html = [],
-						elementsList = this._.elementsPath.list = [];
+						editor = ev.editor,
+						elementsList = editor._.elementsPath.list = [],
+						filters = editor._.elementsPath.filters;
 
 					while ( element )
@@ -115,7 +113,7 @@
 									' onfocus="event.preventBubble();"' : '' ) +
 									' hidefocus="true" ' +
-									' onkeydown="return CKEDITOR._.elementsPath.keydown(\'', this.name, '\',', index, ', event);"' +
+									' onkeydown="return CKEDITOR._.elementsPath.keydown(\'', editor.name, '\',', index, ', event);"' +
 									extra ,
-									' onclick="return CKEDITOR._.elementsPath.click(\'', this.name, '\',', index, ');"',
+									' onclick="return CKEDITOR._.elementsPath.click(\'', editor.name, '\',', index, ');"',
 									' role="button" aria-labelledby="' + idBase + index + '_label">',
 										name,
@@ -204,16 +202,2 @@
 	}
 };
-
-/**
- * A list of filter functions to determinate whether an element should display in elements path bar.
- * @type Array Array of functions that optionaly return 'false' to prevent the element from displaying.
- * @default  []
- * @example
- *	// Prevent elements with attribute 'myAttribute' to appear in elements path.
- *	editor.config.elementsPath_filters.push( function( element )
- *	{
- *		if( element.hasAttribute( 'myAttribute') )
- *			return false;
- *	});
- */
-CKEDITOR.config.elementsPath_filters = [];
Index: CKEditor/branches/versions/3.3.x/_source/plugins/enterkey/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/enterkey/plugin.js	(revision 5378)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/enterkey/plugin.js	(revision 5388)
@@ -101,5 +101,6 @@
 					// a Shift+Enter (#77). Create a new block element instead
 					// (later in the code).
-					if ( !forceMode && !headerTagRegex.test( previousBlock.getName() ) )
+					if ( previousBlock.is( 'li' ) ||
+						 !( forceMode || headerTagRegex.test( previousBlock.getName() ) ) )
 					{
 						// Otherwise, duplicate the previous block.
